using System.Security.Claims;
using e_suite.API.Common;
using e_suite.UnitTestCore;
using eSuite.API.Controllers;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Moq;

namespace eSuite.API.UnitTests.Controllers.SsoManagerControllerUnitTests;

public abstract class SsoProivderControllerTestBase : TestBase
{
    protected Mock<ISsoManager> SsoManagerMock = null!;
    protected SsoManagerController SsoManagerController = null!;

    public override async Task Setup()
    {
        await base.Setup();
        SsoManagerMock = new Mock<ISsoManager>();
        SsoManagerController = new SsoManagerController(SsoManagerMock.Object);

        const long id = -1;
        const string email = "email@mail.test";
        const string displayName = "Testy McTester";

        AddAuthorisedUserToController(id, email, displayName);
    }

    protected void AddAuthorisedUserToController(long id, string email, string displayName)
    {
        var user = new ClaimsPrincipal(new ClaimsIdentity(new Claim[]
        {
            new(ClaimTypes.PrimarySid, id.ToString()),
            new(ClaimTypes.Email, email),
            new(ClaimTypes.Name, displayName)
            // other required and custom claims
        }, "TestAuthentication"));

        SsoManagerController.ControllerContext = new ControllerContext
        {
            HttpContext = new DefaultHttpContext { User = user }
        };
    }
}